<?php
/*
********************************************************************************
 BIBLIO plugin for CMSimple
 -----------------------------------------------
 Author  :  Ricardo Serpell (ricardo@serpell.cl)
 Creation:  03/2008 (mm/yyyy)
 Version :  V 1.0 beta 2 (pre-release)
 
 Plugin to create and manage bibliographic references

 TO DO: 
	Not so much
********************************************************************************
*/
global $pth, $plugin, $rs_biblio;

$rs_biblio['plugindir'] = basename(dirname(__FILE__),"/");

if (!isset($rs_biblio['lang']['main']['Yes'])) if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/languages/en.php') {echo 'Could not include language file';}
$rs_biblio['config']['reference-sets'][0]	= ($rs_biblio['lang']['main']['any']!='' ? $rs_biblio['lang']['main']['any'] : 'any');

if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/config/config.php') {echo 'Could not include Config file';}
if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/config/'.$rs_biblio['config']['entry-data']) {echo 'Could not include basic Entry-Data file';}
if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/lib/rs_functions.php') {echo 'Could not include required general functions';}
if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/lib/entry-render.php') {echo 'Could not include reference formatting function';}
if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/lib/import-RIS.php') {echo 'Could not include RIS file format import function';}
if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/lib/entry-add.php') {echo 'Could not include Entry Recorder library';}
if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/lib/entry-navigator.php') {echo 'Could not include Entry Navigator library';}
if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/lib/entry-formular.php') {echo 'Could not include Entry Formular library';}
if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/lib/quotes-formular.php') {echo 'Could not include Quote/Comments Formular library';}
if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/lib/tech-memo-formular.php') {echo 'Could not include Entry Tech-Memo Formular library';}
if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/lib/file-manager.php') {echo 'Could not include File management library';}
if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/lib/search.php') {echo 'Could not include search library';}

if (!function_exists('rs_toup')) { function rs_toup($value){return strtoupper(strtr($value, '', ''));}}

/* Function to display login form */	
function rs_biblio_login($action){
	global $pth, $sn, $su, $rs_biblio;
	setcookie('rsbibliopass','',time()-$rs_biblio['config']['cookievalidtime']);
	$rs_biblio['plugindir'] = basename(dirname(__FILE__),"/");
	$t ='<FORM method="post" action="'.$sn.'?'.$su.'&amp;action='.$action.'">'.chr(13).chr(10);
	$t.='<input type="password" name="clave" id="password" value=""><input type="submit" name="submit" id="submit" value="'.$rs_biblio['lang']['login']['Login'].'"></form>'; 
	return $t;
	}
	
/* Function to sort the indexing array */	
function rs_biblio_asort($data, $sortingkey){
	settype($index, "array");
	foreach($data as $entry => $value){
		if ($sortingkey=='added') {$index[$entry]=$entry;}
		else {$index[$entry]=$data[$entry][$sortingkey];}
		}
	asort($index);
	return $index;
	}

/* Function to show filter form and filter entries */
function rs_biblio_filterform($task, $subtitle){
	global $pth, $sn, $su, $rs_biblio;
	
	if ($rs_biblio['multiuser'] and isset($_SESSION['filter'])) {
		$rs_biblio['sortby'] = $_SESSION['sortby'];
		$rs_biblio['refstyle'] =	$_SESSION['refstyle'];
		foreach($_SESSION['filter'] as $kk =>$value) { $rs_biblio['filter'][$kk] = $_SESSION['filter'][$kk];}
		}
	else { if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/config/filter-options.php') {echo 'Could not include filter-options file';} }
	
	$filtered=0;
	foreach($rs_biblio['data'] as $entry =>$value){
		/* filter by bibliographic sets */
		$show=false;
		$i = count($rs_biblio['config']['reference-sets']);
		if (!$rs_biblio['filter']['set-0']) {
			for ($j=1; $j<= $i; $j++) {
				if (!$rs_biblio['filter']['set-'.$j]) continue;
				$needle = $rs_biblio['config']['reference-sets'][$j];
				if (substr_count($rs_biblio['data'][$entry]['Belongs-to'],$needle)>0) $show=true;
				}
			}
		else $show=true;
		if (!$show) continue;
		/* filter by attribute */
		$show=true;
		if (!$rs_biblio['filter']['atr-serial']) {if ($rs_biblio['data'][$entry]['Serial']=='true') $show=false;}
		if (!$rs_biblio['filter']['atr-part']) {if ($rs_biblio['data'][$entry]['Part']=='true') $show=false;}
		if (!$rs_biblio['filter']['atr-electronic']) {if ($rs_biblio['data'][$entry]['Electronic']=='true') $show=false;}
		if (!$show) continue;
		/* filter by document type */
		$show=false;
		$i = count($rs_biblio['config']['docutype']);
		foreach($rs_biblio['docutype'] as $key => $value) {
			if (!$rs_biblio['filter']['docu-'.$key]) continue;
			if ($rs_biblio['data'][$entry]['Type']==$key) {$show=true; $filtered++;$passing[$entry]=true;}
			}
		}
	
	$dir = $pth['folder']['plugins'].$rs_biblio['plugindir'].'/config';
	$dh  = opendir($dir);	unset($rs_biblio['refstyle-files']);
	$rs_biblio['refstyle-files']=''; $i=0;
	while (false !== ($filename = readdir($dh))) {if (substr_count($filename, 'refstyle-')>0) {$i++; $rs_biblio['refstyle-files'][$i]=str_replace('refstyle-', '', str_replace('.php', '', $filename));}}
	closedir($dh);
	
	$t.='<FORM method="post" action="'.$sn.'?'.$su.'&amp;action='.($task=='search' ? 'search' : $task.'-'.($subtitle!='' ? $subtitle :  'title')).'&amp;filter=true">'.chr(13).chr(10);
	
	if ($task=='search') {
		$searchterms = (get_magic_quotes_gpc() ? stripslashes($_POST['searchterms']) : $_POST['searchterms']);
		$t.='<INPUT type="hidden" name="searchterms" value="'.$searchterms.'">'.chr(13).chr(10);
		}
	$t.='<BR><TABLE class="biblio" cellspacing="4"><TBODY>'.chr(13).chr(10);
	$t.='    <TR class="biblio"><TD class="biblio"><strong>'.$rs_biblio['lang']['main']['Display entries'].':</strong></TD>'.chr(13).chr(10);
	$t.='        <TD class="biblio" ><em>&nbsp;'.$rs_biblio['lang']['main']['Sorted by'].':</em></TD>'.chr(13).chr(10);
	$t.='        <TD class="biblio" ><em>&nbsp;'.$rs_biblio['lang']['main']['Reference Style'].':</em></TD></TR>'.chr(13).chr(10);
	$t.='    <TR class="biblio"><TD class="biblio">&nbsp;</TD>'.chr(13).chr(10);
	$t.='         <TD class="biblio"><select name="sortby" onchange="location.href=this.options[this.selectedIndex].value" style="width:150px">'.chr(13).chr(10);
	$t.='              <option value="'.$sn.'?'.$su.'&amp;action='.($task=='search' ? 'search' : $task).'-title&amp;filter=true" '.($rs_biblio['sortby']=='title' ? 'selected' : '').'>'.$rs_biblio['lang']['main']['Title'].'</option>'.chr(13).chr(10);
	$t.='              <option value="'.$sn.'?'.$su.'&amp;action='.($task=='search' ? 'search' : $task).'-author&amp;filter=true" '.($rs_biblio['sortby']=='author' ? 'selected' : '').'>'.$rs_biblio['lang']['main']['Author'].'</option>'.chr(13).chr(10);
	$t.='              <option value="'.$sn.'?'.$su.'&amp;action='.($task=='search' ? 'search' : $task).'-date&amp;filter=true" '.($rs_biblio['sortby']=='date' ? 'selected' : '').'>'.$rs_biblio['lang']['main']['Publication Date'].'</option>'.chr(13).chr(10);
	$t.='              <option value="'.$sn.'?'.$su.'&amp;action='.($task=='search' ? 'search' : $task).'-added&amp;filter=true" '.($rs_biblio['sortby']=='added' ? 'selected' : '').'>'.$rs_biblio['lang']['main']['Date Added'].'</option>'.chr(13).chr(10);
	$t.='            </select></TD>'.chr(13).chr(10);
	$t.='         <TD class="biblio"><select name="sortby" onchange="location.href=this.options[this.selectedIndex].value" style="width:150px">'.chr(13).chr(10);
	foreach ($rs_biblio['refstyle-files'] as $key => $style) {
		$t.='              <option value="'.$sn.'?'.$su.'&amp;action='.($task=='search' ? 'search' : $task).'-'.$rs_biblio['sortby'].'&amp;filter=true&amp;refstyle='.$style.'" '.($rs_biblio['refstyle']==$style ? 'selected' : '').'>'.$style.'</option>'.chr(13).chr(10);
		}
	$t.='            </select></TD></TR>'.chr(13).chr(10);
	$t.='    <TR class="biblio"><TD class="biblio" colspan="3"><strong>'.$rs_biblio['lang']['main']['Filter entries'].':</strong></TD></TR>'.chr(13).chr(10);
	$t.='    <TR class="biblio">'.chr(13).chr(10);
	$t.='        <TD class="biblio"><em>&nbsp;'.$rs_biblio['lang']['main']['By atributes'].'</em></TD>'.chr(13).chr(10);
	$t.='        <TD class="biblio"><em>'.$rs_biblio['lang']['main']['By bibliographic set'].'</em></TD>'.chr(13).chr(10);
	$t.='        <TD class="biblio"><em>'.$rs_biblio['lang']['main']['By type of document'].'</em></TD>'.chr(13).chr(10);
	$t.='        </TR>'.chr(13).chr(10);
	$t.='    <TR class="biblio">'.chr(13).chr(10);
	$t.='        <TD class="biblio">'.chr(13).chr(10);
	$t.='             <INPUT class="biblio-radio" type="checkbox" name="atr-serial" value="true" '.($rs_biblio['filter']['atr-serial'] ? 'checked': '').'>'.$rs_biblio['lang']['docudata']['Serial Publication'].'<BR>'.chr(13).chr(10);
	$t.='             <INPUT class="biblio-radio" type="checkbox" name="atr-part" value="true" '.($rs_biblio['filter']['atr-part'] ? 'checked' : '').'>'.$rs_biblio['lang']['docudata']['Part of Publication'].'<BR>'.chr(13).chr(10);
	$t.='             <INPUT class="biblio-radio" type="checkbox" name="atr-electronic" value="true" '.($rs_biblio['filter']['atr-electronic'] ? 'checked' : '').'>'.$rs_biblio['lang']['docudata']['Electronic Format'].'<BR>'.chr(13).chr(10);
	$t.='        </TD>'.chr(13).chr(10);
	$t.='        <TD class="biblio"><SELECT name="reference-sets[]" size="5" multiple="multiple" style="width:150px;">'.chr(13).chr(10);
	foreach($rs_biblio['config']['reference-sets'] as $key => $value){$t.='            <OPTION value="set-'.$key.'" '.($rs_biblio['filter']['set-'.$key] ? 'selected' : '').'>'.$rs_biblio['config']['reference-sets'][$key].'</OPTION>'.chr(13).chr(10);}
	$t.='            </SELECT></TD>'.chr(13).chr(10);
	$t.='        <TD class="biblio"><SELECT name="docutype[]" size="5" multiple="multiple" style="width:150px;">'.chr(13).chr(10);
	foreach($rs_biblio['docutype'] as $key => $value){$t.='            <OPTION value="docu-'.$key.'" '.($rs_biblio['filter']['docu-'.$key] ? 'selected' : '').'>'.$value.'</OPTION>'.chr(13).chr(10);}
	$t.='             </SELECT></TD> </TR>'.chr(13).chr(10);
	$t.='    <TR class="biblio"><TD class="biblio"><INPUT class="biblio-submit" name="filterbutton" type="submit" value="'.$rs_biblio['lang']['main']['Filter'].'"></TD>'.chr(13).chr(10);
	$t.='                             <TD class="biblio" colspan="2"><em>'.$rs_biblio['lang']['main']['Current subset contains'].': <strong>'.$filtered.'</strong> '.($filtered!=1 ? $rs_biblio['lang']['main']['bibliographic entries'] : $rs_biblio['lang']['main']['bibliographic entry']).'</em></TD></TR>'.chr(13).chr(10);

	$t.='    </TBODY></TABLE>'.chr(13).chr(10);
	$t.='</FORM><BR>'.chr(13).chr(10);

	return array($t, $passing);
}

/* main function to display root menu or other options */
function rs_biblio_main($vacio){
	global $o, $pth, $sn, $su, $rs_biblio;
	if(headers_sent($filename,$linenum)){$t.="ERROR : someone has already sent headers, look for the error in $filename line $linenum";echo $t; exit;}
	if ((get_magic_quotes_gpc()) or (get_magic_quotes_runtime())) set_magic_quotes_runtime(false);
	$login='';
	$dologin='false';
	if ($rs_biblio['config']['login']!='') {
		if (isset($_POST['clave'])) {
			$login=$_POST['clave'];
			setcookie('rsbibliopass',$login,time()+$rs_biblio['config']['cookievalidtime']);
			}
		else {
			if (!isset($_COOKIE)) {
				global $_COOKIE;
				$_COOKIE = $GLOBALS['HTTP_COOKIE_VARS'];
				}
			if ($_COOKIE['rsbibliopass']==$rs_biblio['config']['login']) {
				$login=$_COOKIE['rsbibliopass'];
				setcookie('rsbibliopass',$login,time()+$rs_biblio['config']['cookievalidtime']);
				}
			else $dologin='true';
			}
		}
	/* check and configure multiuser mode */
	$e_full = true;  $e_mod = true;
	if ($rs_biblio['config']['user'] =='') {
		if (isset($_SESSION['Name'])) {
			$rs_biblio['user'] = (isset($_SESSION['Real Name']) ? $_SESSION['Real Name'] : $_SESSION['Name']);
			$rs_biblio['multiuser'] = true;
			$rs_biblio['accesslevel'] = $_SESSION['accesslevel'];
			$e_full = false;
			$e_mod = false;
			if (strstr(str_replace(' ', '', $rs_biblio['config']['modaccesslevel']).',',$rs_biblio['accesslevel'].',')) $e_mod= true;
			if (strstr(str_replace(' ', '', $rs_biblio['config']['addaccesslevel']).',',$rs_biblio['accesslevel'].',')) $e_full= true;
			}
		else {
			$rs_biblio['user'] = 'Unknown User';
			$rs_biblio['multiuser'] = false;
			}
		}
	else {
		$rs_biblio['user'] = $rs_biblio['config']['user'];
		$rs_biblio['multiuser'] = false;
		}
	
	$action= isset($_POST['action']) ? $_POST['action'] : $_GET['action'];
	$filter = isset($_POST['filter']) ? $_POST['filter'] : $_GET['filter'];
	$number= isset($_POST['number']) ? $_POST['number'] : $_GET['number'];
	$origin= isset($_POST['origin']) ? $_POST['origin'] : $_GET['origin'];
	if ($filter=='true') $filter=true;
	
	if ($login==$rs_biblio['config']['login']){
	/* if login is correct then process the plugin functions... */
		
		if ($rs_biblio['multiuser'] and isset($_SESSION['filter'])) {
			$rs_biblio['sortby'] = $_SESSION['sortby'];
			$rs_biblio['refstyle'] =	$_SESSION['refstyle'];
			foreach($_SESSION['filter'] as $kk =>$value) { $rs_biblio['filter'][$kk] = $_SESSION['filter'][$kk];}
			}
		else { if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/config/filter-options.php') {echo 'Could not include filter-options file';} }
		
		/* Show main menu as default */
		$t=chr(13).chr(10);
		$t.='<TABLE class="biblio"><TBODY>'.chr(13).chr(10);
		$t.='    <TR class="biblio">'.chr(13).chr(10);
		$t.='            <TD class="biblio"><FORM method="post" action="'.$sn.'?'.$su.'&amp;action=render-'.$rs_biblio['sortby'].'"><INPUT class="biblio-submit" name="button1" type="submit" value="'.$rs_biblio['lang']['main']['List'].'"></FORM></TD>'.chr(13).chr(10);
		$t.='            <TD class="biblio"><FORM method="post" action="'.$sn.'?'.$su.'&amp;action=listentry-'.$rs_biblio['sortby'].'"><INPUT class="biblio-submit" name="button2" type="submit" value="'.(($e_full or $e_mod) ? $rs_biblio['lang']['main']['Manage'] : $rs_biblio['lang']['main']['Browse']).'"></FORM></TD>'.chr(13).chr(10);
		if ($e_full) $t.='            <TD class="biblio"><FORM method="post" action="'.$sn.'?'.$su.'&amp;action=addentry"><INPUT class="biblio-submit" name="button3" type="submit" value="'.$rs_biblio['lang']['main']['Add'].'"></FORM></TD>'.chr(13).chr(10);
		$t.='            <TD class="biblio"><FORM method="post" action="'.$sn.'?'.$su.'&amp;action=search">';
		$searchterms = (get_magic_quotes_gpc() ? stripslashes($_POST['searchterms']) : $_POST['searchterms']);
		$t.='<INPUT class="biblio-submit" name="button4" type="submit" value="'.$rs_biblio['lang']['main']['Search'].'">&nbsp;<INPUT class="biblio-text" name="searchterms" type="text" '.(substr_count($action, 'search')>0 ? 'value="'.rs_validhtml($searchterms).'" ' : '').'></FORM></TD>'.chr(13).chr(10);
		$t.='        </TR>'.chr(13).chr(10);
		$t.='    </TBODY></TABLE>'.chr(13).chr(10);
	
		/* Sets the filtering options if changed by the user */
		if ($filter) {
			if (isset($_POST['docutype'])) {
				unset($rs_biblio['filter']);
				$i = count($rs_biblio['config']['reference-sets']);
				for ($j=0; $j<= $i; $j++) {$rs_biblio['filter']['set-'.$j]='false';} 
				foreach($_POST['reference-sets'] as $key =>$value) {$rs_biblio['filter'][$value]='true';}
				foreach($rs_biblio['docutype'] as $key => $value) { $rs_biblio['filter']['docu-'.$key]='false';}
				foreach($_POST['docutype'] as $key =>$value) {$rs_biblio['filter'][$value]='true';}
				$rs_biblio['filter']['atr-serial']= ($_POST['atr-serial']!='true' ? 'false' : 'true');
				$rs_biblio['filter']['atr-part']= ($_POST['atr-part']!='true' ? 'false': 'true');
				$rs_biblio['filter']['atr-electronic']= ($_POST['atr-electronic']!='true' ? 'false': 'true');
				}
			else {
				$rs_biblio['sortby']=str_replace('-', '', strstr($action,'-'));
				}
			
			$ref = isset($_POST['refstyle']) ? $_POST['refstyle'] : $_GET['refstyle'];
			if ($ref!='')  $rs_biblio['refstyle']=$ref;
			
			if (!$rs_biblio['multiuser']) {
				$contents='<?php'.chr(10).'/* This file is best modifyed through the filter form in the page */'.chr(10);
				$contents.='$rs_biblio['.chr(39).'sortby'.chr(39).']='.chr(39).$rs_biblio['sortby'].chr(39).';'.chr(10);
				$contents.='$rs_biblio['.chr(39).'refstyle'.chr(39).']='.chr(39).$rs_biblio['refstyle'].chr(39).';'.chr(10);
				foreach($rs_biblio['filter'] as $entry =>$value) {$contents.='$rs_biblio['.chr(39).'filter'.chr(39).']['.chr(39).$entry.chr(39).']= '.($value=='true' ? 'true' : 'false').';'.chr(10);}
				$contents.='?>'.chr(13).chr(10);
				$filename = $pth['folder']['plugins'].$rs_biblio['plugindir'].'/config/filter-options.php';
				if (is_writable($filename)) { 
					if (!$handle = fopen($filename, 'w+')) {$t = 'Cannot open file ('.$filename.')'; $success=false;}
					if (fwrite($handle, $contents) === FALSE) {$t = 'Cannot write to file ('.$filename.')'; $success=false;}
					fclose($handle);
					$success=true;
					} 
				}
			else {
				$_SESSION['sortby'] = $rs_biblio['sortby'];
				$_SESSION['refstyle'] = $rs_biblio['refstyle'];
				foreach($rs_biblio['filter'] as $entry =>$value) { $_SESSION['filter'][$entry] = ($rs_biblio['filter'][$entry]=='true' ? true : false);}
				}
			}
	
		/*Confirm before deleting entries or quotes/comments in entries */
		if ((substr_count($action,'confirm')>0) and ($e_full or $e_mod)) {
			if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/data/data.php') {echo 'Could not include Data file';}
			$t.='<BR><H4 class="biblio">'.$rs_biblio['lang']['main']['Attention!'].'</H4>'.chr(13).chr(10);
			$t.='<p class="biblio">'.$rs_biblio['lang']['main']['Are you sure you want to delete'];
			if (substr_count($action,'entry')>0) {
				$t.=' '.$rs_biblio['lang']['main']['this entry'].':</p>'.chr(13).chr(10);
				$entry=str_replace('confirm-entry-','',$action);
				$kind='entry';
				$number='';
				$t.=rs_biblio_render($entry);
				}
			else {
				if (substr_count($action,'quote')>0) {
					$t.=' '.$rs_biblio['lang']['main']['this quote'].':</p>'.chr(13).chr(10);
					$entry=str_replace('confirm-quote-','',$action);
					$kind='quote';
					}
				else {
					$t.=' '.$rs_biblio['lang']['main']['this comment'].':</p>'.chr(13).chr(10);
					$entry=str_replace('confirm-comment-','',$action);
					$kind='comment';
					}
				$t.='<TABLE class="biblio" width="100%"><TBODY>'.chr(13).chr(10);
				$t.='    <TR>'.chr(13).chr(10);
				$t.='        <TD class="biblio">'.$number.'-</TD>'.chr(13).chr(10);
				$t.='        <TD class="biblio">'.$rs_biblio['lang']['main']['Type'].'</TD>'.chr(13).chr(10);
				$t.='        <TD class="biblio">'.$rs_biblio[$kind][$entry][$number]['Type'].'</TD>'.chr(13).chr(10);
				$t.='        </TR>'.chr(13).chr(10);
				$t.='    <TR>'.chr(13).chr(10);
				$t.='        <TD class="biblio">&nbsp;</TD>'.chr(13).chr(10);
				$t.='        <TD class="biblio">'.$rs_biblio['lang']['main']['Date added'].'</TD>'.chr(13).chr(10);
				$t.='        <TD class="biblio">'.$rs_biblio[$kind][$entry][$number]['Date'].'</TD>'.chr(13).chr(10);
				$t.='        </TR>'.chr(13).chr(10);
				if (isset($rs_biblio[$kind][$entry][$number]['Notes'])) {
					$t.='    <TR>'.chr(13).chr(10);
					$t.='        <TD class="biblio">&nbsp;</TD>'.chr(13).chr(10);
					$t.='        <TD class="biblio">'.$rs_biblio['lang']['main']['Notes'].'</TD>'.chr(13).chr(10);
					$t.='        <TD class="biblio">'.$rs_biblio[$kind][$entry][$number]['Notes'].'</TD>'.chr(13).chr(10);
					$t.='        </TR>'.chr(13).chr(10);
					}
				$t.='    <TR>'.chr(13).chr(10);
				$t.='        <TD class="biblio">&nbsp;</TD>'.chr(13).chr(10);
				$t.='        <TD class="biblio">&nbsp;</TD>'.chr(13).chr(10);
				$t.='        <TD class="biblio"><HR class="biblio">'.rs_renderhtml(rs_validhtml($rs_biblio[$kind][$entry][$number]['Content'])).'</TD>'.chr(13).chr(10);
				$t.='        </TR>'.chr(13).chr(10);
				$t.='    <TR>'.chr(13).chr(10);
				$t.='        <TD class="biblio" colspan="3">&nbsp;</TD>'.chr(13).chr(10);
				$t.='        </TR></TBODY></TABLE>'.chr(13).chr(10);
			}
		$t.='<BR>'.chr(13).chr(10);
		$t.='<FORM method="post" action="'.$sn.'?'.$su.'&amp;action=delete-'.$kind.'-'.$entry.(($number!='') ? '&amp;number='.$number : '').($origin!='' ? '&amp;origin='.$origin : '').'">';
		$t.='<INPUT class="biblio" type="button" name="No" value="'.$rs_biblio['lang']['main']['No'].'" onClick="history.go(-1);return true;">'.chr(13).chr(10);
		$t.='<INPUT class="biblio" type="submit" name="Yes" value="'.$rs_biblio['lang']['main']['Yes'].'"></FORM>'.chr(13).chr(10);
		}
		
		/*Delete entries or quotes/comments in entries */
		if ((substr_count($action,'delete')>0) and ($e_full or $e_mod)){
			if (substr_count($action,'entry')>0) {
				if ($e_full) {
					unset($new);
					$new['entry']=str_replace('delete-entry-','',$action);
					$new['delete-entry']=$new['entry'];
					$action='listentry-'.$rs_biblio['sortby'];
					$kind='data';
					}
				}
			else {
				if (substr_count($action,'quote')>0) {
					unset($new);
					$entry=str_replace('delete-quote-','',$action);
					$new['delete-quote']=$number;
					$new['quote-entry']=$entry;
					$action='editquote-'.$entry;
					$kind='comment';
					}
				else {
					if (substr_count($action,'comment')>0) {
						unset($new);
						$entry=str_replace('delete-comment-','',$action);
						$new['delete-comment']=$number;
						$new['comment-entry']=$entry;
						$action='editcomment-'.$entry;
						$kind='quote';
						}
					else {
						if ($e_full) {
							$file=str_replace('delete-file-','',$action);
							unlink($pth['folder']['plugins'].$rs_biblio['plugindir'].'/data/files/'.$file);
							$entry=substr($file,0,12);
							$action='managefiles-'.$entry;
							}
						}
					}
				}
			rs_biblio_add($new);
			unset($rs_biblio[$kind]);
			if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/data/data.php') {echo 'Could not include Data file';}
			unset($number);
			}
		
		/* Process add-entry or edit entry forms */
		if (substr_count($action,'process')>0) {
			if ((substr_count($action,'quote')==0) and (substr_count($action,'comment')==0) and (substr_count($action,'techmemo')==0)) {
				unset($new);
				unset($new['belongs-to']);
				foreach($_POST as $key => $value) {
					if (get_magic_quotes_gpc()) $value=stripslashes($value);
					if (substr_count($key,'data-')>0) $new[str_replace('_',' ',str_replace('data-','',$key))]=$value;
					if (substr_count($key,'Belongs-to')>0) {
						$new['Belongs-to'].=($new['Belongs-to']!='' ? ', ' : '').$value;
						unset($new[str_replace('_',' ',str_replace('data-','',$key))]);
						}
					}
					if (!isset($new['Belongs-to'])) $new['Belongs-to']=$rs_biblio['config']['reference-sets'][1];
					if ($new['entry']=='dummy') $new['entry']='';
					$new['isquote']=false;
				if(rs_biblio_add($new)) {
					$t.='<span class="biblio"><em>'.$rs_biblio['lang']['main']['Data saved'].'</em></span>';
					$action=($new['entry']=='' ? 'editentry-'.$rs_biblio['lastentry']: 'editentry-'.$new['entry']);
					}
				else {
					$t.='<span class="biblio"><em>'.$rs_biblio['lang']['main']['error saving data'].'</em></span>';
					$action=($new['entry']=='' ? 'editentry-'.$rs_biblio['lastentry']: 'editentry-'.$new['entry']);
					}
				}
			else {
				if (substr_count($action,'techmemo')<1) {
					if (substr_count($action,'quote')>0) {$kind='quote';}
					else {$kind='comment';}
					$entry = str_replace('process-'.$kind.'-','',$action);
					$new['entry']=$entry;	$new['isquote']=true;
					if (($_POST[$kind.'-type']!='') or ($_POST[$kind.'-content']!='') or ($_POST[$kind.'-notes']!='')) {
						$new[$kind]['Type']=$_POST[$kind.'-type'];
						$new[$kind]['Content']=(get_magic_quotes_gpc() ? stripslashes($_POST[$kind.'-content']) : $_POST[$kind.'-content']);
						$new[$kind]['Notes']=(get_magic_quotes_gpc() ? stripslashes($_POST[$kind.'-notes']) : $_POST[$kind.'-notes']);
						$new['kind']=$kind;
						if (isset($number)) $new['number']=$number;
						if(rs_biblio_add($new)) {
							$t.='<span class="biblio"><em>'.$rs_biblio['lang']['main']['Data saved'].'</em></span>';
							$action='edit'.$kind.'-'.$entry;
							$number='';
							}
						else $t.='<span class="biblio"><em>'.$rs_biblio['lang']['main']['error saving data'].'</em></span>';
						}
					else {
						$action='edit'.$kind.'-'.$entry;
						$t.='<span class="biblio"><em>'.$rs_biblio['lang']['main']['nothing to save'].'</em></span>';
						}
					}
				else {
					$entry = str_replace('process-techmemo-','',$action);
					$new['entry']=$entry; $new['isquote']=true;
					$new['comment']['Type']=$rs_biblio['commenttype']['Principal Findings'];
					$new['comment']['Content']=(get_magic_quotes_gpc() ? stripslashes($_POST['findings-content']) : $_POST['findings-content']);
					$new['comment']['Notes']='Tech Memo for: '.(get_magic_quotes_gpc() ? stripslashes($_POST['prepared-for']) : $_POST['prepared-for']);
					$new['comment']['Date']=$_POST['tech-memo-date'];
					$new['kind']='comment';
					if ($_POST['findings-num']!='') $new['number']=$_POST['findings-num'];
					rs_biblio_add($new);
					unset($new); $new['entry']=$entry; $new['isquote']=true;
					$new['comment']['Type']=$rs_biblio['commenttype']['Remarkable Conclusions'];
					$new['comment']['Content']=(get_magic_quotes_gpc() ? stripslashes($_POST['conclusions-content']) : $_POST['conclusions-content']);
					$new['comment']['Notes']='Tech Memo by: '.(get_magic_quotes_gpc() ? stripslashes($_POST['prepared-by']) : $_POST['prepared-by']);
					$new['comment']['Date']=$_POST['tech-memo-date'];
					$new['kind']='comment';
					if ($_POST['conclusions-num']!='') $new['number']=$_POST['conclusions-num'];
					rs_biblio_add($new);
					unset($new); $new['entry']=$entry; $new['isquote']=true;
					$new['comment']['Type']=$rs_biblio['commenttype']['Additional Comments'];
					$new['comment']['Content']=(get_magic_quotes_gpc() ? stripslashes($_POST['additional-content']) : $_POST['additional-content']);
					$new['comment']['Notes']='Tech Memo';
					$new['comment']['Date']=$_POST['tech-memo-date'];
					$new['kind']='comment';
					if ($_POST['additional-num']!='') $new['number']=$_POST['additional-num'];
					rs_biblio_add($new);
					$t.='<span class="biblio"><em>'.$rs_biblio['lang']['main']['Data saved'].'</em></span>';
					$action='techmemo-'.$entry;
					}
				}
			}

		/* ADD new entry */
		if ((substr_count($action,'addentry')>0) and ($e_full)) {
			$t.='<BR>'.chr(13).chr(10).'<H4 class="biblio" id="maintitle">'.$rs_biblio['lang']['main']['Add a new bibliographic entry'].'</H4>'.chr(13).chr(10);
			$t.='<H5 class="biblio"><strong>'.$rs_biblio['lang']['main']['Import from RIS file'].'</strong></H5>'.chr(13).chr(10);
			if (($origin=='import') and ($_FILES['userfile']['error']==0)) {
				$t.='File: '.$_FILES['userfile']['name'].'<BR>';
				$t.='Size: '.$_FILES['userfile']['size'].'<BR>';
				move_uploaded_file($_FILES['userfile']['tmp_name'], $pth['folder']['plugins'].$rs_biblio['plugindir'].'/data/upload.ris');
				$contents='';
				$filename = $pth['folder']['plugins'].$rs_biblio['plugindir'].'/data/upload.ris';
				if (is_readable($filename)) { 
					if (!$handle = fopen($filename, 'r')) {$t = 'Cannot open file ('.$filename.')'; $success=false;}
					$contents=fread($handle, filesize($filename));
					fclose($handle);
					$success=true;
					$new=rs_import_ris($contents);
					unset($quote);
					$quote_count=$new['quotecount'];
					if ($quote_count>'0') {
						for ($q=1; $q==$new['quotecount']; $q++){
							$quote[$q]['quote']['Type']=$new['quote'][$q]['Type'];
							$quote[$q]['quote']['Content']=$new['quote'][$q]['Content'];
							$quote[$q]['quote']['Notes']=$new['quote'][$q]['Notes'];
							$quote[$q]['kind']='quote';
							$quote[$q]['isquote']=true;
							}
						}
					unset($new['quotecount']);
					unset($new['quote']);
					unset($comment);
					$comment_count=$new['commentcount'];
					if ($comment_count>'0') {
						for ($q=1; $q==$new['commentcount']; $q++){
							$comment[$q]['comment']['Type']=$new['comment'][$q]['Type'];
							$comment[$q]['comment']['Content']=$new['comment'][$q]['Content'];
							$comment[$q]['comment']['Notes']=$new['comment'][$q]['Notes'];
							$comment[$q]['kind']='comment';
							$comment[$q]['isquote']=true;
							}
						}
					unset($new['commentcount']);
					unset($new['comment']);
						unset($rs_biblio['lastentry']);
					$new['Belongs-to']=$rs_biblio['config']['reference-sets'][1];
					if(rs_biblio_add($new)) {
						echo 'test';
						$t.='<BR>'.chr(13).chr(10).'<em>'.$rs_biblio['lang']['main']['Data uploaded and saved'].'</em><BR>&nbsp;'.chr(13).chr(10);
						$action='editentry-'.$rs_biblio['lastentry'];
						$origin='main';
						if (isset($quote)) {for ($q=1; $q==$quote_count; $q++){$quote[$q]['entry']=$rs_biblio['lastentry']; rs_biblio_add($quote[$q]);}}
						if (isset($comment)) {for ($q=1; $q==$quote_count; $q++){$comment[$q]['entry']=$rs_biblio['lastentry']; rs_biblio_add($comment[$q]);}}
						}
					}
				else {$t.= 'The file ('.$filename.') is not readable';$success=false;}
				}
			else {
				$t.='<form enctype="multipart/form-data" action="'.$sn.'?'.$su.'&amp;action=addentry&amp;origin=import" method="POST">'.chr(13).chr(10);
				$t.='<input class="biblio" type="hidden" name="MAX_FILE_SIZE" value="90000">'.chr(13).chr(10);
				$t.=$rs_biblio['lang']['main']['File name (use button to browse)'].': ';
				$t.='<input class="biblio-file" name="userfile" type="file" size="37" '.($origin=='import' ? 'value="'.$_FILES['userfile']['name'].'"' : '').'>';
				$t.='<BR><input class="biblio-submit" name="button5" type="submit" value="'.$rs_biblio['lang']['main']['Upload'].'" />';
				$t.='</FORM>';
				$t.=rs_biblio_entryform('',$origin);
				}
			}
		/* Tech-Memo of entry */
		if (substr_count($action,'techmemo')>0) {
			if (substr_count($action,'print')>0) {$entry=str_replace('techmemo-print-','',$action);$t=rs_biblio_techmemo($entry, true); return($t);}
			else {$entry=str_replace('techmemo-','',$action); $t.=rs_biblio_techmemo($entry, false);}
			}
		
		/* Edit an entry */
		if ((substr_count($action,'editentry')>0) and ($e_full)) {
			$entry=str_replace('editentry-','',$action);
			$t.='<BR>'.chr(13).chr(10).'<H4 class="biblio">'.$rs_biblio['lang']['main']['Selected entry'].'</H4>'.chr(13).chr(10);
			$t.=rs_biblio_entryform($entry,$origin);
			}
		
		/* Edit/add quotes/comments */
		if (substr_count($action,'editquote')>0) {$entry=str_replace('editquote-','',$action); $subedit=true; $kind='quote';}
		if (substr_count($action,'editcomment')>0) {$entry=str_replace('editcomment-','',$action); $subedit=true; $kind='comment';}
		if ($subedit) {$t.=rs_biblio_quoteform($entry,$kind,$number,$origin);}
		
		/* Manage Files */
		if (substr_count($action,'managefiles')>0) {
			$entry=str_replace('managefiles-','',$action); $subedit=true;
			if ($origin=='upload') {
				if ($_FILES['userfile']['error']==0){move_uploaded_file($_FILES['userfile']['tmp_name'], $pth['folder']['plugins'].$rs_biblio['plugindir'].'/data/files/'.$entry.'-'.str_replace(' ','_',($_POST['newfilename']!='' ? $_POST['newfilename'] : $_FILES['userfile']['name'])));}
				else {$t.='An error was found while uploading file: '.$_FILES['userfile']['error'].' '.($_FILES['userfile']['name']!='' ? $_FILES['userfile']['name'] : 'unable to retrieve file name').chr(13).chr(10);}
				}
			if ($subedit) {$t.=rs_biblio_filesform($entry, $origin);}
			}
				
		/* Search and show resuls of search */
		if (substr_count($action,'search')>0) {
			$searchterms=$_POST['searchterms'];
			$results=rs_biblio_search($searchterms);
			$index=$results['index'];
			if ($index!='') {$action='listentry';	$search=true;}
			else {
				if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/data/data.php') {echo 'Could not include Data file';}
				unset($passing); 
				list($texto, $passing) = rs_biblio_filterform('search', $rs_biblio['sortby']);	
				$t.=$texto.chr(13).chr(10);
				$t.='<BR><H4 class="biblio" id="maintitle">'.$rs_biblio['lang']['main']['Search results'].'</H4>'.chr(13).chr(10);
				$t.='<p class="biblio">'.$rs_biblio['lang']['main']['No results'].'</p>'.chr(13).chr(10);
				}
			}
				
		/* List entries to select for edit if requested */
		if (substr_count($action,'listentry')>0) {
			if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/data/data.php') {echo 'Could not include Data file';}
			if (!$search) {
				settype($index, "array");
				if ($rs_biblio['sortby']=='author') $index=rs_biblio_asort($rs_biblio['data'], 'Main author');
				if ($rs_biblio['sortby']=='title') $index=rs_biblio_asort($rs_biblio['data'], 'Main title');
				if ($rs_biblio['sortby']=='date') $index=rs_biblio_asort($rs_biblio['data'], 'Year of edition');
				if ($rs_biblio['sortby']=='added') $index=rs_biblio_asort($rs_biblio['data'], 'added');
				}
			unset($passing); 
			list($texto, $passing) = rs_biblio_filterform(($search ? 'search' : 'listentry'), $rs_biblio['sortby']);	
			$t.=$texto.chr(13).chr(10);
			$t.=($search ? '<H4 class="biblio" id="maintitle">'.$rs_biblio['lang']['main']['Search results'].'</H4>' : '<H4 class="biblio" id="maintitle">'.$rs_biblio['lang']['main']['Manage bibliographic entries'].'</H4>').chr(13).chr(10);
			$dir = $pth['folder']['plugins'].$rs_biblio['plugindir'].'/data/files';
			$dh  = opendir($dir);
			unset($files);
			while (false !== ($filename = readdir($dh))) {if (strlen($filename)>12) {$rs_biblio['files'][substr($filename,0,12)]++;}}
			closedir($dh);
			$t.='<TABLE class="biblio"><TBODY>'.chr(13).chr(10);
			$info=$rs_biblio['sortby'];
			$results = false;
			foreach($index as $entry =>$value){
				if (!$passing[$entry]) continue;	
				if ($search) $info=$index[$entry].'%';
				$results = true;
				$t.='    <TR class="biblio"><TD colspan="2"><HR></TD></TR>'.chr(13).chr(10);
				$t.= rs_biblio_navigator($entry, $info);
				}
			if (!$results) {if ($search) $t.='<p class="biblio">'.$rs_biblio['lang']['main']['No filtered results'].'</p>'.chr(13).chr(10);}
			$t.='    </TBODY></TABLE>'.chr(13).chr(10);
			}
			
		/* Render bibliography */
		if (substr_count($action,'render')>0) {
			if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/data/data.php') {echo 'Could not include Data file';}
			settype($index, "array");
			if ($rs_biblio['sortby']=='author') $index=rs_biblio_asort($rs_biblio['data'], 'Main author');
			if ($rs_biblio['sortby']=='title') $index=rs_biblio_asort($rs_biblio['data'], 'Main title');
			if ($rs_biblio['sortby']=='date') $index=rs_biblio_asort($rs_biblio['data'], 'Year of edition');
			if ($rs_biblio['sortby']=='added') $index=rs_biblio_asort($rs_biblio['data'], 'added');
			unset($passing); 
			list($texto, $passing) = rs_biblio_filterform('render', $rs_biblio['sortby']);	
			$t.=$texto.chr(13).chr(10);
			$t.='<H4 class="biblio" id="maintitle">'.$rs_biblio['lang']['main']['List of Bibliographic References'].':</H4>'.chr(13).chr(10);
			foreach($index as $entry =>$value){if (!$passing[$entry]) continue;$t.='<p class="biblio">'.rs_biblio_render($entry).'</p>'.chr(13).chr(10);}
			}
		
		/* When no action is selected yet */
		if ($action=='') {
			if (!include $pth['folder']['plugins'].$rs_biblio['plugindir'].'/data/data.php') {echo 'Could not include Data file';}
			list($texto, $passing) = rs_biblio_filterform( 'listentry', $rs_biblio['sortby']);
			$t.=$texto.chr(13).chr(10);
			}
		
		$t.='<BR>&nbsp;'.chr(13).chr(10);
		}
	else {
		$t='<p class="biblio">'.$rs_biblio['lang']['login']['Wrong password, try again?'].'</p>'.chr(13).chr(10);
		$t.=rs_biblio_login($action);
		}
	if ($dologin=='true') $t='<p class="biblio">'.$rs_biblio['lang']['login']['This page is password protected'].'</p>'.chr(13).chr(10).rs_biblio_login($action);

/* notes:
   nothing right now.
*/
	return '<DIV class="bibliomain">'.$t.'</DIV>';
	}


?>