<?php

/*
********************************************************************************
* Function to write valid php special chars 
********************************************************************************
*/	
if (!function_exists('rs_validphp')) {
	function rs_validphp($value){
		unset($valid);
		stripcslashes($value);
		for ($a=0; $a<=strlen($value); $a++) {
			switch (substr($value,$a,1)) {
				case "'": $valid .=chr(39).'.chr(39).'.chr(39); break;
				case '"': $valid .=chr(39).'.chr(34).'.chr(39); break;
				case chr(92): $valid .=chr(39).'.chr(92).'.chr(39); break;
				default: $valid .= substr($value,$a,1);
				}
			}
		return ($valid);
		}
	}
/*
********************************************************************************
* Function to write valid html special chars (I know it existes... but)
********************************************************************************
*/	
if (!function_exists('rs_validhtml')) {
	function rs_validhtml($value){
		# deprecated
		return htmlentities($value, ENT_QUOTES);
		}
	}

/*
********************************************************************************
* Function to create a table row with cell content from array $cellcontent
********************************************************************************
*/
if (!function_exists('rs_bookings_row')) {
	function rs_bookings_row($cellcontent, $celltags, $cellcount, $rowtags){
		$t = '        <TR '.$rowtags.'>'.chr(13).chr(10);
		for ($b = 1; $b < $cellcount; $b++){
			$t .= '            <TD '.$celltags[$b].'>'.$cellcontent[$b].'</TD>'.chr(13).chr(10);
			}
		$t .= '            <TD class="rightborder" '.$celltags[$b].'>'.$cellcontent[$b].'</TD>'.chr(13).chr(10);
		$t .= '            </TR>'.chr(13).chr(10);
		return $t;
		}
	}
/*
********************************************************************************	
* Function to render html code from text
********************************************************************************
*/
if (!function_exists('rs_renderhtml')) {
	function rs_renderhtml($value){
		$valid ='';
		for ($a=0; $a<=strlen($value); $a++) {
			switch (substr($value,$a,1)) {
				case chr(10): $valid .='<BR>'; break;
				case ' ': $valid .=' '; break;
				default: $valid .= substr($value,$a,1);
				}
			}
		return ($valid);
		}
	}

/*
********************************************************************************	
* Function to create a combo box
********************************************************************************
*/
if (!function_exists('rs_combobox')) {
	function rs_combobox($options) {
	$t='';
	$t.='<select name="'.$options['name'].'"'.($options['class']!='' ? ' class="'.$options['class'].'"' : '').'>'.chr(13).chr(10);
	for ($a=0; $a<count($options['item']); $a++) {
		$t.='    <option value="'.$options['item'][$a]['value'].'"'.($options['item'][$a]['text']==$options['selected'] ? ' selected="true"' : '').'>'.rs_validhtml($options['item'][$a]['text']).chr(13).chr(10);
		}
	$t.='</select>'.chr(13).chr(10);
	return $t;	
	}
}
	
	
	
	
/*
********************************************************************************
* Function to validate different type of text inputs

usage: $type may be one or more of the following flags:

nospaces:		input text must not contain spaces
year:		a 4 digit year (valed if positive or negative)
monthnum:		an positive integer number between 1 and 12
numbersonly:	Numbers, integer or float, positive or negative (commas or points are valid)
mathonly:		Similar to numbersonly but accepts mathematical simbols (no greek letters though)
textonly:		Only alphabetical text (NO NUMBERS IN THIS CATHEGORY).
nospecial:	No special characters (most useful for alphanumerical entries).

********************************************************************************
*/
if (!function_exists('rs_validinput')) {
	function rs_validinput($value, $types){
		$arguments=split(",",$types);
		if (count($arguments)<1) {return(false);}
		$result = true;
		foreach($arguments as $type) {
			if ($type == 'nospaces') {
				if (substr_count(' ', $value)>0) {return(false);}
				}
			if ($type == 'year') {
				str_replace(' ','',$value);
				str_replace(',','',$value);
				str_replace('.','',$value);
				if (strlen($value)<5) {return(false);}
				if (intval($value)!=$value) {return(false);}
				$type == 'numbersonly';
				}
			if ($type == 'monthnum') {
				str_replace(' ','',$value);
				str_replace(',','',$value);
				str_replace('.','',$value);
				if (strlen($value)<2) {return(false);}
				if (intval($value)!=$value) {return(false);}
				if (($value<1)||($value>12)) {return(false);}
				$type == 'numbersonly';
				}
			if ($type == 'numbersonly') {
				str_replace(' ','',$value);
				$test = 0;
				$test = substr_count($value,'-')+substr_count($value,',')+substr_count($value,'.')+substr_count($value, '1')+substr_count($value,'2')+substr_count($value,'3')+substr_count($value,'4')+substr_count($value,'5')+substr_count($value,'6')+substr_count($value,'7')+substr_count($value,'8')+substr_count($value,'9')+substr_count($value,'0');
				if ($test!=strlen($value)) {return(false);}
				}
			if ($type == 'mathonly') {
				str_replace(' ','',$value);
				$test = 0;
				for ($i = 40; $i<=62; $i++) {$test = $test+substr_count($value, chr($i));}
				if ($test!=strlen($value)) {return(false);}
				}
			if ($type == 'textonly') {
				for ($i = 0; $i <=9; $i++) {if (substr_count($value, $i)>0) {return(false);}}
				for ($i = 0; $i <=31; $i++) {if (substr_count($value, chr($i))>0) {return(false);}}
				for ($i = 169; $i <=172; $i++) {if (substr_count($value, chr($i))>0) {return(false);}}
				for ($i = 176; $i <=223; $i++) {if (substr_count($value, chr($i))>0) {return(false);}}
				for ($i = 253; $i <=254; $i++) {if (substr_count($value, chr($i))>0) {return(false);}}
				}
			if ($type == 'nospecial') {
				for ($i = 0; $i <=31; $i++) {if (substr_count($value, chr($i))>0) {return(false);}}
				for ($i = 169; $i <=172; $i++) {if (substr_count($value, chr($i))>0) {return(false);}}
				for ($i = 176; $i <=223; $i++) {if (substr_count($value, chr($i))>0) {return(false);}}
				for ($i = 253; $i <=254; $i++) {if (substr_count($value, chr($i))>0) {return(false);}}
				}
			if ($type == 'is_email') {
				str_replace(' ', '', $value);
				if (substr_count($value, '@')!=1) return(false);
				if (substr_count($value, '.')<1) return(false);
				$arroba = strpos($value, '@');
				$name = substr($value, 0, $arroba);
				if (strlen($name)<1) return(false);
				$address = substr($value, $arroba+1, strlen($value)-$arroba);
				if (strlen($address)<3) return(false); 
				}
			if ($type == 'not_email') {
				str_replace(' ', '', $value);
				if (substr_count($value, '@')!=0) {
					$arroba = strpos($value, '@');
					if (substr($value,$arroba-1,1)!=' ') {
						$address = substr($value, $arroba+1, strlen($value)-$arroba);
						if (substr_count($address, '.')>0) return(false);
						} 
					}
				}
			} 
		return($result);
		}
	}


?>